// Program 8.19 i boken.
package spill;    // Fil: spill/AbstraktGrensesnitt.java

public abstract class AbstraktGrensesnitt implements IGrensesnitt {
  protected Spillebrett brett;
  private boolean lkkePgr;
  private boolean klarForNesteTrekk;

  public void settBrett(Spillebrett brett) {                          // (1)
    this.brett = brett;
  }

  public void brikkeBleSluppet() {                                    // (2)
    if (lkkePgr) {
      klarForNesteTrekk = true;
      visSpillebrett();
    } else {
      kjrSpillLkke();
    }
  }

  public void spillEndteUavgjort() {                                  // (3)
    visBeskjed("Spill endte uavgjort.");
  }

  public void spillerHarVunnet(IBrikkeIdentitet brikke) {             // (4)
    visBeskjed(identitetSomTekst(brikke) + " har vunnet");
  }

  public void kjrSpillLkke() {                                      // (5)
    klarForNesteTrekk = true;
    visSpillebrett();
    lkkePgr = true;
    while (klarForNesteTrekk && !brett.erSpillFerdig())
      spillEtTrekk();
    lkkePgr = false;
  }

  private void spillEtTrekk() {                                       // (6)
    IBrikkeIdentitet brikke = brett.nesteBrikke();
    visNesteBrikke(brikke);
    DeltakerIdentitet deltaker = (DeltakerIdentitet) brikke;
    klarForNesteTrekk = false;
    deltaker.utfrTrekk(brett);
  }

  protected void visNesteBrikke(IBrikkeIdentitet brikke) {            // (7)
    visBeskjed("Neste trekk skal utfres av " + identitetSomTekst(brikke));
  }

  protected String identitetSomTekst(IBrikkeIdentitet brikke) {       // (8)
    DeltakerIdentitet deltaker = (DeltakerIdentitet) brikke;
    return deltaker.tekstRepresentasjon;
  }

  protected abstract void visSpillebrett();
  protected abstract void visBeskjed(String tekst);
}
