package spill.swing;    // Fil: spill/swing/LettSwingSpill.java
import java.awt.Color;

import spill.IBrikkeIdentitet;
import spill.Spillebrett;

/** Et lett spill hvor brukeren spiller mot en maskinmotstander som
    gjr trekk p mf. */
public class LettSwingSpill {
  public static void main(String args[]) {
    SpillSwingGrensesnitt grensesnitt = new SpillSwingGrensesnitt();
    IBrikkeIdentitet[] deltakere = new IBrikkeIdentitet[] { 
      new KomponentFargeIdentitet(new SwingSpiller(grensesnitt), Color.BLUE, 
				  "Spiller 1"),
      new KomponentFargeIdentitet(new SwingSpiller(grensesnitt), Color.YELLOW, 
				  "Spiller 2")
    };
    IBrikkeIdentitet tomRute = new KomponentFargeIdentitet(null, Color.GRAY, "");
    Spillebrett brett = new Spillebrett(deltakere, tomRute, grensesnitt);
    grensesnitt.startGrensesnitt();

  }
}
