package spill.swing;    // Fil: spill/swing/SpillSwingGrensesnitt.java
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import spill.AbstraktGrensesnitt;
import spill.IBrikkeIdentitet;
import spill.Spillebrett;

public class SpillSwingGrensesnitt extends AbstraktGrensesnitt {
  Container brettKomponenter;
  Container topplinje;
  JLabel beskjed;
  JFrame ramme;

  SpillSwingGrensesnitt() {
    ramme = new JFrame("Fire p rad");
    
    Container vindu = ramme.getContentPane();    
    vindu.setLayout(new BorderLayout());

    topplinje = new JPanel();
    topplinje.setLayout(new FlowLayout(FlowLayout.LEFT));
    beskjed = new JLabel("Nytt spill startet");
    JButton nyttSpill = new JButton("Nytt Spill");
    ActionListener nyttSpillHandling = new ActionListener() {
      public void actionPerformed(ActionEvent event) {
	brett.nullstill();
	kjrSpillLkke();
      }
    };
    nyttSpill.addActionListener(nyttSpillHandling);
    
    topplinje.add(nyttSpill);
    topplinje.add(beskjed);
    vindu.add(topplinje, BorderLayout.NORTH);

    brettKomponenter = new JPanel();
    vindu.add(brettKomponenter, BorderLayout.CENTER);
  }

  public void settBrett(Spillebrett brett) {
    super.settBrett(brett);

    int kolonner = Spillebrett.KOLONNE_ANTALL;
    int rader = Spillebrett.RAD_ANTALL;  
    brettKomponenter.setLayout(new GridLayout(kolonner, rader + 1));

    for (int kolonne = 0; kolonne < kolonner; ++kolonne) {
      brettKomponenter.add(lagSlippKnapp(kolonne));
    }
    
    for (int rad = 0; rad < Spillebrett.RAD_ANTALL; ++rad) {
      for (int kolonne = 0; kolonne < kolonner; ++kolonne) {
        JComponent rute = new JLabel("");
        rute.setBorder(BorderFactory.createEtchedBorder());
	rute.setOpaque(true);
	brettKomponenter.add(rute);
      }
    }
  }

  Component lagSlippKnapp(final int kolonne) {
    JButton slippKnapp = new JButton("Slipp");
    ActionListener slippHandling = new ActionListener() {
      public void actionPerformed(ActionEvent event) {
	brett.slippBrikkeNedKolonne(brett.nesteBrikke(), kolonne);
      }
    };
    slippKnapp.addActionListener(slippHandling);
    return slippKnapp;
  }


  protected void visSpillebrett() {
    for (int kolonne = 0; kolonne < Spillebrett.KOLONNE_ANTALL; ++kolonne) {
      settSlippTillatelseForKolonne(kolonne, false);

      for (int rad = 0; rad < Spillebrett.RAD_ANTALL; ++rad) {
	IBrikkeIdentitet brikke = brett.brikkeVed(kolonne, rad);
	KomponentFargeIdentitet identitet = (KomponentFargeIdentitet) brikke;
        Component komponent = komponentForRute(kolonne, rad);
	identitet.fargeleggKomponent(komponent);	
      }
    }
  }    

  void settSlippTillatelseForKolonne(int kolonne, boolean slippErTillatt) {
    Component knapp = brettKomponenter.getComponent(kolonne);
    knapp.setEnabled(slippErTillatt);
  }

  Component komponentForRute(int kolonne, int rad) {
    return brettKomponenter.getComponent((Spillebrett.RAD_ANTALL - rad) 
					 * Spillebrett.KOLONNE_ANTALL + kolonne);
  }
  protected void visBeskjed(String tekst) {
    beskjed.setText(tekst);
  }

  public void startGrensesnitt() {
    kjrSpillLkke();    
    ramme.pack();
    ramme.setVisible(true);
  }
};
