// Program 8.20 i boken.
package spill.terminal;    // Fil: spill/terminal/TerminalSpiller.java
import java.util.Scanner;

import spill.IBrikkeIdentitet;
import spill.ISpiller;
import spill.Spillebrett;

public class TerminalSpiller implements ISpiller {
  public void utfrTrekk(IBrikkeIdentitet brikke, Spillebrett brett) {
    assert !brett.erSpillFerdig();
    brett.slippBrikkeNedKolonne(brikke, beOmKolonneValg(brett));
  }

  private int beOmKolonneValg(Spillebrett brett) {
    Scanner scanner = new Scanner(System.in);
    while (true) {
      System.out.print("Hvilken kolonne skal brikken slippes ned i? ");

      if (scanner.hasNextInt()) {
        int kolonne = scanner.nextInt();
        if (brett.erGyldigKolonneValg(kolonne)) {
          scanner.nextLine(); // Hopp over resten av linjen.
          return kolonne;
        }
      }
      scanner.nextLine(); // Hopp over resten av linjen.
      System.out.println("Ugyldig kolonnevalg. Prv igjen.");
    }
  }
}
