// Program 8.10 i boken.
// Fil: SpillTekstGrensesnitt.java
import java.util.Scanner;

public class SpillTekstGrensesnitt {
  Spillebrett brett;

  static String spillebrettRadSomTekst(Spillebrett brett, int rad) {
    final int ANTALL_KOLONNER = 7;
    final int SISTE_KOLONNE = ANTALL_KOLONNER - 1;
    String radTekst = "|";
    for (int kolonne = 0; kolonne < SISTE_KOLONNE; ++kolonne)
      radTekst += spillebrettRuteSomTekst(brett, kolonne, rad) + " ";
    return radTekst + spillebrettRuteSomTekst(brett, SISTE_KOLONNE, rad) + "|";
  }

  static char spillebrettRuteSomTekst(Spillebrett brett, int kolonne, int rad) {
    char tilstand = brett.brikkeVed(kolonne, rad);
    if (tilstand == Spillebrett.TOM_RUTE)
      return '.';
    return tilstand;
  }

  static String spillebrettSomTekst(Spillebrett brett) {
    String tekst = " 0 1 2 3 4 5 6\n";
    final int VERSTE_RAD = 5;
    for (int rad = VERSTE_RAD; rad >= 0; --rad)
      tekst += spillebrettRadSomTekst(brett, rad) + "\n";
    return tekst + "===============\n";
  }

  public void visSpillebrett() {
    System.out.print(spillebrettSomTekst(brett));
  }

  SpillTekstGrensesnitt() {
    brett = new Spillebrett();
  }

  void kjrSpillLkke() {
    visSpillebrett();
    while (!brett.erSpillFerdig()) {
      spillEtTrekk();
      visSpillebrett();
    }
  }

  void spillEtTrekk() {
    char brikke = brett.nesteBrikke();
    visNesteBrikke(brikke);
    ISpiller spiller = brett.nesteSpiller();
    spiller.utfrTrekk(brett);
  }

  void visNesteBrikke(char brikke) {
    System.out.printf("Neste brikke som skal slippes er '%s'.\n", brikke);
  }

  int beOmKolonneValg() {
    Scanner scanner = new Scanner(System.in);
    while (true) {
      System.out.print("Hvilken kolonne skal brikken slippes ned i? ");

      if (scanner.hasNextInt()) {
        int kolonne = scanner.nextInt();
        if (brett.erGyldigKolonneValg(kolonne)) {
          scanner.nextLine(); // Hopp over resten av linjen.
          return kolonne;
        }
      }
      scanner.nextLine(); // Hopp over resten av linjen.
      System.out.println("Ugyldig kolonnevalg. Prv igjen.");
    }
  }
}
